<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Minimal, flexible command-line parser"><meta name="keywords" content="rust, rustlang, rust-lang, clap_lex"><title>clap_lex - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="../crates.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc mod crate"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../clap_lex/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../clap_lex/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Crate clap_lex</a></h2><div class="sidebar-elems"><div class="block"><ul><li class="version">Version 0.2.4</li><li><a id="all-types" href="all.html">All Items</a></li></ul></div><section><div class="block"><ul><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../clap_lex/index.html"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Crate <a class="mod" href="#">clap_lex</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/clap_lex/lib.rs.html#1-484">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Minimal, flexible command-line parser</p>
<p>As opposed to a declarative parser, this processes arguments as a stream of tokens.  As lexing
a command-line is not context-free, we rely on the caller to decide how to interpret the
arguments.</p>
<h2 id="examples"><a href="#examples">Examples</a></h2>
<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">struct</span> <span class="ident">Args</span> {
    <span class="ident">paths</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">PathBuf</span><span class="op">&gt;</span>,
    <span class="ident">color</span>: <span class="ident">Color</span>,
    <span class="ident">verbosity</span>: <span class="ident">usize</span>,
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">enum</span> <span class="ident">Color</span> {
    <span class="ident">Always</span>,
    <span class="ident">Auto</span>,
    <span class="ident">Never</span>,
}

<span class="kw">impl</span> <span class="ident">Color</span> {
    <span class="kw">fn</span> <span class="ident">parse</span>(<span class="ident">s</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">clap_lex::RawOsStr</span><span class="op">&gt;</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident">BoxedError</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="ident">s</span>.<span class="ident">map</span>(<span class="op">|</span><span class="ident">s</span><span class="op">|</span> <span class="ident">s</span>.<span class="ident">to_str</span>().<span class="ident">ok_or</span>(<span class="ident">s</span>));
        <span class="kw">match</span> <span class="ident">s</span> {
            <span class="prelude-val">Some</span>(<span class="prelude-val">Ok</span>(<span class="string">&quot;always&quot;</span>)) <span class="op">|</span> <span class="prelude-val">Some</span>(<span class="prelude-val">Ok</span>(<span class="string">&quot;&quot;</span>)) <span class="op">|</span> <span class="prelude-val">None</span> =&gt; {
                <span class="prelude-val">Ok</span>(<span class="ident">Color::Always</span>)
            }
            <span class="prelude-val">Some</span>(<span class="prelude-val">Ok</span>(<span class="string">&quot;auto&quot;</span>)) =&gt; {
                <span class="prelude-val">Ok</span>(<span class="ident">Color::Auto</span>)
            }
            <span class="prelude-val">Some</span>(<span class="prelude-val">Ok</span>(<span class="string">&quot;never&quot;</span>)) =&gt; {
                <span class="prelude-val">Ok</span>(<span class="ident">Color::Never</span>)
            }
            <span class="prelude-val">Some</span>(<span class="ident">invalid</span>) =&gt; {
                <span class="prelude-val">Err</span>(<span class="macro">format!</span>(<span class="string">&quot;Invalid value for `--color`, {:?}&quot;</span>, <span class="ident">invalid</span>).<span class="ident">into</span>())
            }
        }
    }
}

<span class="kw">fn</span> <span class="ident">parse_args</span>(
    <span class="ident">raw</span>: <span class="kw">impl</span> <span class="ident">IntoIterator</span><span class="op">&lt;</span><span class="ident">Item</span><span class="op">=</span><span class="kw">impl</span> <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">std::ffi::OsString</span><span class="op">&gt;</span><span class="op">&gt;</span>
) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Args</span>, <span class="ident">BoxedError</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">args</span> <span class="op">=</span> <span class="ident">Args</span> {
        <span class="ident">paths</span>: <span class="ident">Vec::new</span>(),
        <span class="ident">color</span>: <span class="ident">Color::Auto</span>,
        <span class="ident">verbosity</span>: <span class="number">0</span>,
    };

    <span class="kw">let</span> <span class="ident">raw</span> <span class="op">=</span> <span class="ident">clap_lex::RawArgs::new</span>(<span class="ident">raw</span>);
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">cursor</span> <span class="op">=</span> <span class="ident">raw</span>.<span class="ident">cursor</span>();
    <span class="ident">raw</span>.<span class="ident">next</span>(<span class="kw-2">&amp;mut</span> <span class="ident">cursor</span>);  <span class="comment">// Skip the bin</span>
    <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">arg</span>) <span class="op">=</span> <span class="ident">raw</span>.<span class="ident">next</span>(<span class="kw-2">&amp;mut</span> <span class="ident">cursor</span>) {
        <span class="kw">if</span> <span class="ident">arg</span>.<span class="ident">is_escape</span>() {
            <span class="ident">args</span>.<span class="ident">paths</span>.<span class="ident">extend</span>(<span class="ident">raw</span>.<span class="ident">remaining</span>(<span class="kw-2">&amp;mut</span> <span class="ident">cursor</span>).<span class="ident">map</span>(<span class="ident">PathBuf::from</span>));
        } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">arg</span>.<span class="ident">is_stdio</span>() {
            <span class="ident">args</span>.<span class="ident">paths</span>.<span class="ident">push</span>(<span class="ident">PathBuf::from</span>(<span class="string">&quot;-&quot;</span>));
        } <span class="kw">else</span> <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">long</span>, <span class="ident">value</span>)) <span class="op">=</span> <span class="ident">arg</span>.<span class="ident">to_long</span>() {
            <span class="kw">match</span> <span class="ident">long</span> {
                <span class="prelude-val">Ok</span>(<span class="string">&quot;verbose&quot;</span>) =&gt; {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">value</span>) <span class="op">=</span> <span class="ident">value</span> {
                        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format!</span>(<span class="string">&quot;`--verbose` does not take a value, got `{:?}`&quot;</span>, <span class="ident">value</span>).<span class="ident">into</span>());
                    }
                    <span class="ident">args</span>.<span class="ident">verbosity</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
                }
                <span class="prelude-val">Ok</span>(<span class="string">&quot;color&quot;</span>) =&gt; {
                    <span class="ident">args</span>.<span class="ident">color</span> <span class="op">=</span> <span class="ident">Color::parse</span>(<span class="ident">value</span>)<span class="question-mark">?</span>;
                }
                <span class="kw">_</span> =&gt; {
                    <span class="kw">return</span> <span class="prelude-val">Err</span>(
                        <span class="macro">format!</span>(<span class="string">&quot;Unexpected flag: --{}&quot;</span>, <span class="ident">arg</span>.<span class="ident">display</span>()).<span class="ident">into</span>()
                    );
                }
            }
        } <span class="kw">else</span> <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="kw-2">mut</span> <span class="ident">shorts</span>) <span class="op">=</span> <span class="ident">arg</span>.<span class="ident">to_short</span>() {
            <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">short</span>) <span class="op">=</span> <span class="ident">shorts</span>.<span class="ident">next_flag</span>() {
                <span class="kw">match</span> <span class="ident">short</span> {
                    <span class="prelude-val">Ok</span>(<span class="string">&#39;v&#39;</span>) =&gt; {
                        <span class="ident">args</span>.<span class="ident">verbosity</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
                    }
                    <span class="prelude-val">Ok</span>(<span class="string">&#39;c&#39;</span>) =&gt; {
                        <span class="kw">let</span> <span class="ident">value</span> <span class="op">=</span> <span class="ident">shorts</span>.<span class="ident">next_value_os</span>();
                        <span class="ident">args</span>.<span class="ident">color</span> <span class="op">=</span> <span class="ident">Color::parse</span>(<span class="ident">value</span>)<span class="question-mark">?</span>;
                    }
                    <span class="prelude-val">Ok</span>(<span class="ident">c</span>) =&gt; {
                        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format!</span>(<span class="string">&quot;Unexpected flag: -{}&quot;</span>, <span class="ident">c</span>).<span class="ident">into</span>());
                    }
                    <span class="prelude-val">Err</span>(<span class="ident">e</span>) =&gt; {
                        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format!</span>(<span class="string">&quot;Unexpected flag: -{}&quot;</span>, <span class="ident">e</span>.<span class="ident">to_str_lossy</span>()).<span class="ident">into</span>());
                    }
                }
            }
        } <span class="kw">else</span> {
            <span class="ident">args</span>.<span class="ident">paths</span>.<span class="ident">push</span>(<span class="ident">PathBuf::from</span>(<span class="ident">arg</span>.<span class="ident">to_value_os</span>().<span class="ident">to_os_str</span>().<span class="ident">into_owned</span>()));
        }
    }

    <span class="prelude-val">Ok</span>(<span class="ident">args</span>)
}

<span class="kw">let</span> <span class="ident">args</span> <span class="op">=</span> <span class="ident">parse_args</span>([<span class="string">&quot;bin&quot;</span>, <span class="string">&quot;--hello&quot;</span>, <span class="string">&quot;world&quot;</span>]);
<span class="macro">println!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">args</span>);</code></pre></div>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ArgCursor.html" title="clap_lex::ArgCursor struct">ArgCursor</a></div><div class="item-right docblock-short"><p>Position within <a href="struct.RawArgs.html" title="RawArgs"><code>RawArgs</code></a></p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ParsedArg.html" title="clap_lex::ParsedArg struct">ParsedArg</a></div><div class="item-right docblock-short"><p>Command-line Argument</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.RawArgs.html" title="clap_lex::RawArgs struct">RawArgs</a></div><div class="item-right docblock-short"><p>Command-line arguments</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.RawOsStr.html" title="clap_lex::RawOsStr struct">RawOsStr</a></div><div class="item-right docblock-short"><p>A container for borrowed byte strings converted by this crate.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.RawOsString.html" title="clap_lex::RawOsString struct">RawOsString</a></div><div class="item-right docblock-short"><p>A container for owned byte strings converted by this crate.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ShortFlags.html" title="clap_lex::ShortFlags struct">ShortFlags</a></div><div class="item-right docblock-short"><p>Walk through short flags within a <a href="struct.ParsedArg.html" title="ParsedArg"><code>ParsedArg</code></a></p>
</div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.SeekFrom.html" title="clap_lex::SeekFrom enum">SeekFrom</a></div><div class="item-right docblock-short"><p>Enumeration of possible methods to seek within an I/O object.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="clap_lex" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>